<%--

  BEEN: Benchmarking Environment
  ==============================
   
  File author: David Majda

  GNU Lesser General Public License Version 2.1
  ---------------------------------------------
  Copyright (C) 2004-2006 Distributed Systems Research Group,
  Faculty of Mathematics and Physics, Charles University in Prague

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License version 2.1, as published by the Free Software Foundation.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

--%><%@
	include file="includes.jsp"
%><%@ page
	import="cz.cuni.mff.been.benchmarkmanager.*"
	import="cz.cuni.mff.been.benchmarkmanager.gui.*"
	import="cz.cuni.mff.been.benchmarkmanager.plugins.*"
	import="cz.cuni.mff.been.logging.*"
	import="java.util.EnumSet"
%><%
	page_.writeInfoMessages();
	page_.writeErrorMessages();

	AnalysisEntity analysis = (AnalysisEntity)application.getAttribute("analysis");
	ExperimentEntity[] experiments = (ExperimentEntity[])application.getAttribute("experiments");

	String periodicity = null;
	int[] daysOfWeek = null;
	int[] daysOfMonth = null;
	String hours = null;
	String minutes = null;
	if (analysis.isRegression()) {
		periodicity = (String)application.getAttribute("periodicity");
		daysOfWeek = (int[])application.getAttribute("daysOfWeek");
		daysOfMonth = (int[])application.getAttribute("daysOfMonth");
		hours = (String)application.getAttribute("hours");
		minutes = (String)application.getAttribute("minutes");
	}
	LogRecord[] logRecords = (LogRecord[])application.getAttribute("logRecords");
	EnumSet logFields = (EnumSet)application.getAttribute("logFields");
	LogEntityColumn[] logEntityColumns = (LogEntityColumn[])application.getAttribute("logEntityColumns");
	String activeSheet = (String)application.getAttribute("activeSheet");

	List scheduledExperiments = new LinkedList();
	List runningExperiments = new LinkedList();
	List finishedExperiments = new LinkedList();
	for (int i = 0; i < experiments.length; i++) {
		if (experiments[i].getStatus().equals(EntityStatus.SUBMITTED) || experiments[i].getStatus().equals(EntityStatus.DISPATCHED)) {
			scheduledExperiments.add(experiments[i]);
		} else if (experiments[i].getStatus().equals(EntityStatus.RUNNING)) {
			runningExperiments.add(experiments[i]);
		} else if (experiments[i].getStatus().equals(EntityStatus.FINISHED)) {
			finishedExperiments.add(experiments[i]);
		}
	}

	HashMap data = new HashMap();
%>
<div class="bar"><div class="top-left"><div class="top-right"><div class="bottom-left"><div class="bottom-right"><div class="inner">
	<a href="<%=page_.actionURL("analysis-list")%>">Analyses</a>
	&raquo;
	<a
		href="<%=page_.currentActionURL()%>?aid=<%=Routines.htmlspecialchars(analysis.getId().toString())%>"
	><%=Routines.htmlspecialchars(analysis.getName())%></a>
</div></div></div></div></div></div>

<div class="tabsheet">
	<ul class="tabsheet-tabs">
		<li<%=activeSheet.equals("general-sheet") ? " class=\"active\"" : "" %>><a href="#" onclick="tabsheetActivate(this, 'general-sheet'); return false;">General</a></li>
		<% if (analysis.isRegression() && ((RegressionAnalysisEntity)analysis).getSchedule() != null) { %><li<%=activeSheet.equals("scheduling-info-sheet") ? " class=\"active\"" : "" %>><a href="#" onclick="tabsheetActivate(this, 'scheduling-info-sheet'); return false;">Scheduling information</a></li><% } %>
		<li<%=activeSheet.equals("logs-sheet") ? " class=\"active\"" : "" %>><a href="#" onclick="tabsheetActivate(this, 'logs-sheet'); return false;">Logs</a></li>
	</ul>
	<div class="tabsheet-sheets">
		<div id="general-sheet"<%=activeSheet.equals("general-sheet") ? " class=\"tabsheet-sheet-visible\"" : " class=\"tabsheet-sheet-invisible\"" %>>
			<table class="form center-block">
				<tr>
					<td colspan="2"><h2>Analysis information</h2></td>
				</tr>
				<tr>
					<th>Name:</th>
					<td><%=Routines.htmlspecialchars(analysis.getName())%></td>
				</tr>
				<tr>
					<th>Description:</th>
					<td><%=Routines.htmlspecialchars(analysis.getDescription())%></td>
				</tr>
				<tr>
					<th>Type:</th>
					<td><%=analysis.isRegression() ? "regression" : "comparison"%></td>
				</tr>
				<% if (analysis.isRegression() && ((RegressionAnalysisEntity)analysis).getSchedule() != null) { %>
					<tr>
						<td colspan="2"><h2>Model experiment</h2></td>
					</tr>
					<%
						data.clear();
						data.put("roles", ((RegressionAnalysisEntity)analysis).getModel().getBenchmarkRoles());
						data.put("headerLevel", 3);
						out.flush(); // unforunately can't be inside writeTemplate method
						page_.writeTemplate("benchmarks-summary-roles", data);
					%>
					<%
						data.clear();
						data.put("callbackRScripts", ((RegressionAnalysisEntity)analysis).getModel().getScripts());
						data.put("headerLevel", 3);
						out.flush(); // unforunately can't be inside writeTemplate method
						page_.writeTemplate("benchmarks-summary-callback-r-scripts", data);
					%>
				<% } %>
				<tr>
					<td colspan="2"><h2>Experiments</h2></td>
				</tr>
				<tr>
					<td colspan="2">
			<table class="spacing center-block">
				<% if (scheduledExperiments.size() > 0) { %>
					<tr>
						<td><h3>Scheduled Experiments</h3></td>
					</tr>
					<tr>
						<td>
							<%
								data.clear();
								data.put("analysis", analysis);
								data.put("experiments", scheduledExperiments);
								out.flush(); // unforunately can't be inside writeTemplate method
								page_.writeTemplate("benchmarks-analysis-details-inner-table", data);
							%>
						</td>
					</tr>
				<% } %>
				<% if (runningExperiments.size() > 0) { %>
					<tr>
						<td><h3>Running Experiments</h3></td>
					</tr>
					<tr>
						<td>
							<%
								data.clear();
								data.put("analysis", analysis);
								data.put("experiments", runningExperiments);
								out.flush(); // unforunately can't be inside writeTemplate method
								page_.writeTemplate("benchmarks-analysis-details-inner-table", data);
							%>
						</td>
					</tr>
				<% } %>
				<% if (finishedExperiments.size() > 0) { %>
					<tr>
						<td><h3>Finished Experiments</h3></td>
					</tr>
					<tr>
						<td>
							<%
								data.clear();
								data.put("analysis", analysis);
								data.put("experiments", finishedExperiments);
								out.flush(); // unforunately can't be inside writeTemplate method
								page_.writeTemplate("benchmarks-analysis-details-inner-table", data);
							%>
						</td>
					</tr>
				<% } %>
				</table>
				<% if (scheduledExperiments.size() == 0
					&& runningExperiments.size() == 0
					&& finishedExperiments.size() == 0) { %>
					<div class="center">No experiments exist.</div>
				<% } %>
					</td>
				</tr>
			</table>
		</div>
		<% if (analysis.isRegression() && ((RegressionAnalysisEntity)analysis).getSchedule() != null) { %>
			<div id="scheduling-info-sheet"<%=activeSheet.equals("scheduling-info-sheet") ? " class=\"tabsheet-sheet-visible\"" : " class=\"tabsheet-sheet-invisible\"" %>>
				<form id="benchmarks-analysis-details-scheduling-info-form" action="<%=page_.currentActionURL()%>" method="post">
					<input type="hidden" name="aid" value="<%=Routines.htmlspecialchars(analysis.getId().toString())%>" />
					<table class="form center-block">
						<tr>
							<td colspan="2"><h2>Status</h2></td>
						</tr>
						<% if (((RegressionAnalysisEntity)analysis).getSchedule() != null
								 && ((RegressionAnalysisEntity)analysis).getSchedule().isPaused()) { %>
							<tr><td>The analysis is paused.</td></tr>
							<tr><td><input type="submit" name="resume" value="Resume" /></td></tr>
						<% } else { %>
							<tr><td>The analysis is running.</td></tr>
							<tr><td><input type="submit" name="pause" value="Pause" /></td></tr>
						<% } %>
						<tr>
							<th>Last run time:</th>
							<td><%=
								((RegressionAnalysisEntity)analysis).getLastRunDate() != VersionProvider.FIRST_RUN
									? new Date(((RegressionAnalysisEntity)analysis).getLastRunDate()).toString()
									: "N/A"
							%></td>
						</tr>
						<tr>
							<th>Next run time:</th>
							<td><%=
								((RegressionAnalysisEntity)analysis).getNextRunDate() != VersionProvider.FIRST_RUN
									? new Date(((RegressionAnalysisEntity)analysis).getNextRunDate()).toString()
									: "N/A"
							%></td>
						</tr>
						<%
							data.clear();
							data.put("periodicity", periodicity);
							data.put("daysOfWeek", daysOfWeek);
							data.put("daysOfMonth", daysOfMonth);
							data.put("hours", hours);
							data.put("minutes", minutes);
							out.flush(); // unforunately can't be inside writeTemplate method
							page_.writeTemplate("benchmarks-scheduling-info", data);
						%>
						<tr>
							<td class="buttons" colspan="2">
								<input type="submit" class="type-submit" name="change" value="Change" />
							</td>
						</tr>
					</table>
				</form>
			</div>
		<% } %>
		<div id="logs-sheet"<%=activeSheet.equals("logs-sheet") ? " class=\"tabsheet-sheet-visible\"" : " class=\"tabsheet-sheet-invisible\"" %>>
			<%
				data.clear();
				data.put("logRecords", logRecords);
				data.put("logFields", logFields);
				data.put("logEntityColumns", logEntityColumns);
				out.flush(); // unforunately can't be inside writeTemplate method
				page_.writeTemplate("log-view", data);
			%>
		</div>
	</div>
</div>